code    SEGMENT
.286
        ORG 100h
        ASSUME  cs:code,ds:code
Start:
        cld
        call    res                  ;ந樠஢ ணࠬ
        call    fon                  ;뢥 ⠢
        lea     sp,word ptr stek     ;७ ⥪
        mov     dl,2                 ;2764
        call    typ0                 ;⠭ ⨯   㬮砭
        mov     ah,1
        mov     cx,200h
        int     10h                  ;  (607h return)
        mov     ax,sp
        shr     ax,4                 ;᫨ ᥣ 
        mov     cx,es
        add     cx,ax
        mov     ax,2000h             ;஢ 稥  512k (27040)
        cmp     cx,ax
        jnc     no_mem               ;  ᮮ饭  墠⪥ 
        push    es
        mov     es,ax                ;⠭ 砫  2000:0000
        mov     cx,8
cl_buf: push    cx
        xor     ax,ax
        mov     di,ax
        dec     ax
        mov     cx,8000h
rep     stosw                        ;  8*64k
        mov     ax,es
        add     ax,1000h
        mov     es,ax
        pop     cx
        loop    cl_buf
        pop     es
        call    time
klav:
        call    show
        call    clear
        lea     di,k_tab
        call    scan
kl_q:   mov    dx,word ptr[di]
        or     dx,dx
        jz     klav
        mov    word ptr k_buf,dx
        inc    di
        inc    di
        scasb                        ;।  
        jnz    kl_q
        mov    byte ptr k_key,al     ;  
        mov    byte ptr crc_fl,0     ; 䫠 CRC
        call   time
        call   word ptr k_buf        ;맢 ࠭ ணࠬ
        jmp    klav

k_buf   dw     0
k_tab   dw     rom                   ; ணࠬ:
        db     56h                   ;Verify
        dw     rom
        db     52h                   ;Read
        dw     mes_wr
        db     57h                   ;Write
        dw     rom
        db     46h                   ;Test FF
        dw     rom
        db     4Fh                   ;Test Overwrite
        dw     typ
        db     54h
        dw     uprg
        db     55h
        dw     next
        db     4Eh
        dw     load
        db     4Ch
        dw     save
        db     53h
        dw     quit
        db     1Bh
        dw     0                     ;end table

no_mem: lea     dx,no_mm
        call    mes
        ret

quit:   lea     dx,qui
        call    mcan
        cmp     al,'Y'
        jnz     kl_q
        mov     ax,0C00h             ;⠭ ଠ쭮 ﭨ LPT
        call    port
        xor     ax,ax
        push    ax
q_kl:   ret

mcan:   call    mes
scan:   xor     ah,ah
        int     16h
        and     al,0DFh
q_wr:   ret


include rom.asm
include disk.asm

clear:  pusha
        xor     bh,bh
        mov     ah,2
        mov     dx,1312h
        int     10h
        mov     ax,0A20h
        mov     cx,48
        int     10h
        popa
        ret

show:   pusha
        call    say_time
        mov     ax,word ptr b_seg
        sub     ax,2000h
        mov     di,7F0h
        call    dadr
        add     ax,word ptr len
        dec     ax
        mov     di,930h
        call    dadr
        push    es
        push    di
        mov     di,c_seg
        mov     es,di
        mov     di,c_adr
        call    dcur
        pop     di
        pop     es
        mov     dl,byte ptr r_c2
        and     dl,0Fh
        mov     al,endup-begup
        mul     dl
        lea     dx,begup
        add     dx,ax
        mov     bx,0B35h
        call    mesk
        cmp     byte ptr crc_fl,0    ;⪫  CRC
        jnz     en_crc               ; ⨨ 
        xor     bx,bx                ;㫥 CRC
        push    ds
        mov     ax,word ptr b_seg
        mov     ds,ax
        mov     cx,es:word ptr len   ;- ࠣ䮢
b_c_s:  push    cx
        xor     si,si
        mov     cx,16
b_crc:  lodsb
        call    crc
        loop    b_crc
        mov     ax,ds
        inc     ax
        mov     ds,ax
        pop     cx
        call    klv
        jz      kl_ok
        pop     ds
        jmp     en_crc
kl_ok:  loop    b_c_s
        pop     ds
        mov     ax,bx
        mov     di,9D0h
        call    dadr
        mov     byte ptr crc_fl,1
en_crc: popa
        ret

dadr:
        push    es
        push    ax
        mov     ax,0B800h
        mov     es,ax
        pop     ax
        push    ax
        call    hex
        pop     ax
        push    ax
        mov     al,ah
        call    hex
        pop     ax
        pop     es
        ret

dcur:   push    ax
        push    di
        mov     ax,di
        mov     di,892h
        call    dadr
        and     al,0F0h
        ror     ax,4
        mov     di,es
        add     ax,di
        sub     ax,2000h
        mov     di,890h
        call    dadr
        pop     di
        pop     ax
        ret

hex:    aam     10h
        call    hx
hx:     cmp     al,0Ah
        sbb     al,69h
        das
        std
        stosb
        cld
        dec     di
        mov     al,ah
        ret

fon:    mov     ax,3
        int     10h
        lea     si,hlp
        mov     ax,0B820h
        mov     es,ax
        xor     di,di
        mov     cx,918
bg:     mov     al,9
        cmp     byte ptr ds:[si],7Fh
        jnc     graf
        mov     al,2
graf:   cmp     byte ptr ds:[si],32
        jnc     key
        add     byte ptr ds:[si],64
        mov     al,5
key:    movsb
        mov     es:[di],al
        inc     di
        cmp     di,66h
        jne     rs
        xor     di,di
        mov     ax,es
        add     ax,10
        mov     es,ax
rs:     loop    bg
        push    ds
        pop     es
        ret

mes:    mov     bx,1312h
mesk:   push    dx
        push    cx
        push    bx
        xor     bh,bh
        pop     dx
        mov     ah,2
        int     10h
        cmp     dh,13h
        jnz     no_cl
        mov     ax,0A20h
        mov     cx,48
        int     10h
no_cl:  pop     cx
        pop     dx
        mov     ah,9
        int     21h
        ret




crc:    mov     ah,1
ll5:    ror     ax,1
        push    bx
        rcr     bx,1
        and     bx,0C4A0h
        xor     bl,bh
        pop     bx
        clc
        rcl     bx,1
        jpe     ll6
        inc     bl
ll6:    cmp     al,1
        jnz     ll5
        mov     al,ah
        ret

qui     db  'Are you sure quit program ? (Y,Any key)$'
no_mm   db  'There is not enough memory for buffers !$'
k_key   db  0
crc_fl  db  0
hlp     db  'ͻ'
        db  '   **BiDiPro**  EPROM/FLASH programmer rev 1.2a  '
        db  'Ķ'
        db  ' Produced by Eduard Panchenko. Desigh by P.E.co. '
        db  ' E-mail: ed@en.dn.ua           FIDO: 2:4655/3.67 '
        db  'Ķ'
        db  ' Test: ',15,'verwrite/',6,6,'     Type  ROM: 2764         '
        db  '       ',22,'erify           Algoritm : Texas Instr. '
        db  '       ',18,'ead             Uprg, V  : 12.0         '
        db  '       ',23,'rite            Begin ADR: 00000        '
        db  '       ',20,'ype             Curr/Err.: 00000        '
        db  '       ',21,'prg             End   ADR: 01FFF        '
        db  '       ',14,'ext             CRC      : 0000         '
        db  '       ',12,'oad             Time, sec: 0000.00      '
        db  '       ',19,'ave             File name:              '
        db  'Ķ'
        db  '                                                 '
        db  'ͼ'
stek    dw  0
code    ENDS
        END Start



